#!/usr/bin/python

"""
    Copyright (C) 2008 Andreas Engelbredt Dalsgaard <andreas.dalsgaard@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. """

from parser import *
from code_generation import *
from pyuppaal import *

if len(sys.argv) == 1:
    print "usage : ./compile.py inputfile"
    raise SystemExit

cachesize = "4"

if len(sys.argv) >= 2:
    filename = sys.argv[1]

if len(sys.argv) == 3:
    if sys.argv[2] != "":
        cachesize = sys.argv[2]

p = yacc.parse(open(filename).read())
cg = code_generator_uppaal(identifiers)
p.visit(cg, None)
FILE = open("file.xml", "w")
nta = pyuppaal.from_xml(open("AbstractHWModel.xml"))
template = nta.templates[1]
#template.layout(auto_nails=True)
FILE.write(cg.to_xml(template, cachesize))
FILE.close()

# vim:ts=4:sw=4:expandtab
